// Code generated by gowrap. DO NOT EDIT.
// template: ../../../assets/templates/middleware/access_log.tmpl
// gowrap: http://github.com/hexdigest/gowrap

package middleware

//go:generate gowrap gen -p git.perx.ru/perxis/perxis-go/pkg/environments -i Environments -t ../../../assets/templates/middleware/access_log.tmpl -o access_logging_middleware.go -l ""

import (
	"context"
	"time"

	"git.perx.ru/perxis/perxis-go/pkg/auth"
	"git.perx.ru/perxis/perxis-go/pkg/environments"
	"go.uber.org/zap"
)

// accessLoggingMiddleware implements environments.Environments that is instrumented with logging
type accessLoggingMiddleware struct {
	logger *zap.Logger
	next   environments.Environments
}

// AccessLoggingMiddleware instruments an implementation of the environments.Environments with simple logging
func AccessLoggingMiddleware(logger *zap.Logger) Middleware {
	return func(next environments.Environments) environments.Environments {
		return &accessLoggingMiddleware{
			next:   next,
			logger: logger,
		}
	}
}

func (m *accessLoggingMiddleware) Create(ctx context.Context, env *environments.Environment) (created *environments.Environment, err error) {
	begin := time.Now()

	m.logger.Debug("Create.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("env", env),
	)

	created, err = m.next.Create(ctx, env)

	m.logger.Debug("Create.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Reflect("created", created),
		zap.Error(err),
	)

	return created, err
}

func (m *accessLoggingMiddleware) Delete(ctx context.Context, spaceId string, id string) (err error) {
	begin := time.Now()

	m.logger.Debug("Delete.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("spaceId", spaceId),
		zap.Reflect("id", id),
	)

	err = m.next.Delete(ctx, spaceId, id)

	m.logger.Debug("Delete.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Error(err),
	)

	return err
}

func (m *accessLoggingMiddleware) Get(ctx context.Context, spaceId string, id string) (env *environments.Environment, err error) {
	begin := time.Now()

	m.logger.Debug("Get.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("spaceId", spaceId),
		zap.Reflect("id", id),
	)

	env, err = m.next.Get(ctx, spaceId, id)

	m.logger.Debug("Get.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Reflect("env", env),
		zap.Error(err),
	)

	return env, err
}

func (m *accessLoggingMiddleware) List(ctx context.Context, spaceId string) (envs []*environments.Environment, err error) {
	begin := time.Now()

	m.logger.Debug("List.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("spaceId", spaceId),
	)

	envs, err = m.next.List(ctx, spaceId)

	m.logger.Debug("List.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Reflect("envs", envs),
		zap.Error(err),
	)

	return envs, err
}

func (m *accessLoggingMiddleware) Migrate(ctx context.Context, spaceId string, id string, options ...*environments.MigrateOptions) (err error) {
	begin := time.Now()

	m.logger.Debug("Migrate.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("spaceId", spaceId),
		zap.Reflect("id", id),
		zap.Reflect("options", options),
	)

	err = m.next.Migrate(ctx, spaceId, id, options...)

	m.logger.Debug("Migrate.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Error(err),
	)

	return err
}

func (m *accessLoggingMiddleware) RemoveAlias(ctx context.Context, spaceId string, id string, alias string) (err error) {
	begin := time.Now()

	m.logger.Debug("RemoveAlias.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("spaceId", spaceId),
		zap.Reflect("id", id),
		zap.Reflect("alias", alias),
	)

	err = m.next.RemoveAlias(ctx, spaceId, id, alias)

	m.logger.Debug("RemoveAlias.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Error(err),
	)

	return err
}

func (m *accessLoggingMiddleware) SetAlias(ctx context.Context, spaceId string, id string, alias string) (err error) {
	begin := time.Now()

	m.logger.Debug("SetAlias.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("spaceId", spaceId),
		zap.Reflect("id", id),
		zap.Reflect("alias", alias),
	)

	err = m.next.SetAlias(ctx, spaceId, id, alias)

	m.logger.Debug("SetAlias.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Error(err),
	)

	return err
}

func (m *accessLoggingMiddleware) Update(ctx context.Context, env *environments.Environment) (err error) {
	begin := time.Now()

	m.logger.Debug("Update.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("env", env),
	)

	err = m.next.Update(ctx, env)

	m.logger.Debug("Update.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Error(err),
	)

	return err
}
