// Code generated by gowrap. DO NOT EDIT.
// template: ../../../assets/templates/middleware/error_log
// gowrap: http://github.com/hexdigest/gowrap

package middleware

//go:generate gowrap gen -p git.perx.ru/perxis/perxis-go/pkg/files -i Files -t ../../../assets/templates/middleware/error_log -o error_logging_middleware.go -l ""

import (
	"context"

	"git.perx.ru/perxis/perxis-go/pkg/files"
	"go.uber.org/zap"
)

// errorLoggingMiddleware implements files.Files that is instrumented with logging
type errorLoggingMiddleware struct {
	logger *zap.Logger
	next   files.Files
}

// ErrorLoggingMiddleware instruments an implementation of the files.Files with simple logging
func ErrorLoggingMiddleware(logger *zap.Logger) Middleware {
	return func(next files.Files) files.Files {
		return &errorLoggingMiddleware{
			next:   next,
			logger: logger,
		}
	}
}

func (m *errorLoggingMiddleware) AbortUpload(ctx context.Context, upload *files.MultipartUpload) (err error) {
	logger := m.logger
	defer func() {
		if err != nil {
			logger.Warn("response error", zap.Error(err))
		}
	}()
	return m.next.AbortUpload(ctx, upload)
}

func (m *errorLoggingMiddleware) CompleteUpload(ctx context.Context, upload *files.MultipartUpload) (u *files.MultipartUpload, err error) {
	logger := m.logger
	defer func() {
		if err != nil {
			logger.Warn("response error", zap.Error(err))
		}
	}()
	return m.next.CompleteUpload(ctx, upload)
}

func (m *errorLoggingMiddleware) DeleteFile(ctx context.Context, file *files.File) (err error) {
	logger := m.logger
	defer func() {
		if err != nil {
			logger.Warn("response error", zap.Error(err))
		}
	}()
	return m.next.DeleteFile(ctx, file)
}

func (m *errorLoggingMiddleware) GetFile(ctx context.Context, file *files.File) (f *files.File, err error) {
	logger := m.logger
	defer func() {
		if err != nil {
			logger.Warn("response error", zap.Error(err))
		}
	}()
	return m.next.GetFile(ctx, file)
}

func (m *errorLoggingMiddleware) MoveUpload(ctx context.Context, upload *files.MultipartUpload) (file *files.File, err error) {
	logger := m.logger
	defer func() {
		if err != nil {
			logger.Warn("response error", zap.Error(err))
		}
	}()
	return m.next.MoveUpload(ctx, upload)
}

func (m *errorLoggingMiddleware) StartUpload(ctx context.Context, upload *files.MultipartUpload) (u *files.MultipartUpload, err error) {
	logger := m.logger
	defer func() {
		if err != nil {
			logger.Warn("response error", zap.Error(err))
		}
	}()
	return m.next.StartUpload(ctx, upload)
}

func (m *errorLoggingMiddleware) Upload(ctx context.Context, file *files.File) (u *files.Upload, err error) {
	logger := m.logger
	defer func() {
		if err != nil {
			logger.Warn("response error", zap.Error(err))
		}
	}()
	return m.next.Upload(ctx, file)
}
