// Code generated by gowrap. DO NOT EDIT.
// template: ../../../assets/templates/middleware/access_log.tmpl
// gowrap: http://github.com/hexdigest/gowrap

package middleware

//go:generate gowrap gen -p git.perx.ru/perxis/perxis-go/pkg/items -i Items -t ../../../assets/templates/middleware/access_log.tmpl -o access_logging_middleware.go -l ""

import (
	"context"
	"time"

	"git.perx.ru/perxis/perxis-go/pkg/auth"
	"git.perx.ru/perxis/perxis-go/pkg/items"
	"git.perx.ru/perxis/perxis-go/pkg/schema"
	"go.uber.org/zap"
)

// accessLoggingMiddleware implements items.Items that is instrumented with logging
type accessLoggingMiddleware struct {
	logger *zap.Logger
	next   items.Items
}

// AccessLoggingMiddleware instruments an implementation of the items.Items with simple logging
func AccessLoggingMiddleware(logger *zap.Logger) Middleware {
	return func(next items.Items) items.Items {
		return &accessLoggingMiddleware{
			next:   next,
			logger: logger,
		}
	}
}

func (m *accessLoggingMiddleware) Aggregate(ctx context.Context, spaceId string, envId string, collectionId string, filter *items.Filter, options ...*items.AggregateOptions) (result map[string]interface{}, err error) {
	begin := time.Now()

	m.logger.Debug("Aggregate.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("spaceId", spaceId),
		zap.Reflect("envId", envId),
		zap.Reflect("collectionId", collectionId),
		zap.Reflect("filter", filter),
		zap.Reflect("options", options),
	)

	result, err = m.next.Aggregate(ctx, spaceId, envId, collectionId, filter, options...)

	m.logger.Debug("Aggregate.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Reflect("result", result),
		zap.Error(err),
	)

	return result, err
}

func (m *accessLoggingMiddleware) AggregatePublished(ctx context.Context, spaceId string, envId string, collectionId string, filter *items.Filter, options ...*items.AggregatePublishedOptions) (result map[string]interface{}, err error) {
	begin := time.Now()

	m.logger.Debug("AggregatePublished.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("spaceId", spaceId),
		zap.Reflect("envId", envId),
		zap.Reflect("collectionId", collectionId),
		zap.Reflect("filter", filter),
		zap.Reflect("options", options),
	)

	result, err = m.next.AggregatePublished(ctx, spaceId, envId, collectionId, filter, options...)

	m.logger.Debug("AggregatePublished.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Reflect("result", result),
		zap.Error(err),
	)

	return result, err
}

func (m *accessLoggingMiddleware) Archive(ctx context.Context, item *items.Item, options ...*items.ArchiveOptions) (err error) {
	begin := time.Now()

	m.logger.Debug("Archive.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("item", item),
		zap.Reflect("options", options),
	)

	err = m.next.Archive(ctx, item, options...)

	m.logger.Debug("Archive.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Error(err),
	)

	return err
}

func (m *accessLoggingMiddleware) CheckoutRevision(ctx context.Context, spaceID string, envID string, collectionID string, id string, revID string, options ...*items.CheckoutRevisionsOptions) (storedRevID string, err error) {
	begin := time.Now()

	m.logger.Debug("CheckoutRevision.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("spaceID", spaceID),
		zap.Reflect("envID", envID),
		zap.Reflect("collectionID", collectionID),
		zap.Reflect("id", id),
		zap.Reflect("revID", revID),
		zap.Reflect("options", options),
	)

	storedRevID, err = m.next.CheckoutRevision(ctx, spaceID, envID, collectionID, id, revID, options...)

	m.logger.Debug("CheckoutRevision.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Reflect("storedRevID", storedRevID),
		zap.Error(err),
	)

	return storedRevID, err
}

func (m *accessLoggingMiddleware) Create(ctx context.Context, item *items.Item, opts ...*items.CreateOptions) (created *items.Item, err error) {
	begin := time.Now()

	m.logger.Debug("Create.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("item", item),
		zap.Reflect("opts", opts),
	)

	created, err = m.next.Create(ctx, item, opts...)

	m.logger.Debug("Create.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Reflect("created", created),
		zap.Error(err),
	)

	return created, err
}

func (m *accessLoggingMiddleware) Delete(ctx context.Context, item *items.Item, options ...*items.DeleteOptions) (err error) {
	begin := time.Now()

	m.logger.Debug("Delete.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("item", item),
		zap.Reflect("options", options),
	)

	err = m.next.Delete(ctx, item, options...)

	m.logger.Debug("Delete.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Error(err),
	)

	return err
}

func (m *accessLoggingMiddleware) Find(ctx context.Context, spaceId string, envId string, collectionId string, filter *items.Filter, options ...*items.FindOptions) (items []*items.Item, total int, err error) {
	begin := time.Now()

	m.logger.Debug("Find.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("spaceId", spaceId),
		zap.Reflect("envId", envId),
		zap.Reflect("collectionId", collectionId),
		zap.Reflect("filter", filter),
		zap.Reflect("options", options),
	)

	items, total, err = m.next.Find(ctx, spaceId, envId, collectionId, filter, options...)

	m.logger.Debug("Find.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Reflect("items", items),
		zap.Reflect("total", total),
		zap.Error(err),
	)

	return items, total, err
}

func (m *accessLoggingMiddleware) FindArchived(ctx context.Context, spaceId string, envId string, collectionId string, filter *items.Filter, options ...*items.FindArchivedOptions) (items []*items.Item, total int, err error) {
	begin := time.Now()

	m.logger.Debug("FindArchived.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("spaceId", spaceId),
		zap.Reflect("envId", envId),
		zap.Reflect("collectionId", collectionId),
		zap.Reflect("filter", filter),
		zap.Reflect("options", options),
	)

	items, total, err = m.next.FindArchived(ctx, spaceId, envId, collectionId, filter, options...)

	m.logger.Debug("FindArchived.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Reflect("items", items),
		zap.Reflect("total", total),
		zap.Error(err),
	)

	return items, total, err
}

func (m *accessLoggingMiddleware) FindPublished(ctx context.Context, spaceId string, envId string, collectionId string, filter *items.Filter, options ...*items.FindPublishedOptions) (items []*items.Item, total int, err error) {
	begin := time.Now()

	m.logger.Debug("FindPublished.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("spaceId", spaceId),
		zap.Reflect("envId", envId),
		zap.Reflect("collectionId", collectionId),
		zap.Reflect("filter", filter),
		zap.Reflect("options", options),
	)

	items, total, err = m.next.FindPublished(ctx, spaceId, envId, collectionId, filter, options...)

	m.logger.Debug("FindPublished.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Reflect("items", items),
		zap.Reflect("total", total),
		zap.Error(err),
	)

	return items, total, err
}

func (m *accessLoggingMiddleware) Get(ctx context.Context, spaceId string, envId string, collectionId string, id string, options ...*items.GetOptions) (item *items.Item, err error) {
	begin := time.Now()

	m.logger.Debug("Get.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("spaceId", spaceId),
		zap.Reflect("envId", envId),
		zap.Reflect("collectionId", collectionId),
		zap.Reflect("id", id),
		zap.Reflect("options", options),
	)

	item, err = m.next.Get(ctx, spaceId, envId, collectionId, id, options...)

	m.logger.Debug("Get.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Reflect("item", item),
		zap.Error(err),
	)

	return item, err
}

func (m *accessLoggingMiddleware) GetArchived(ctx context.Context, spaceID string, envID string, collectionID string, id string, options ...*items.GetArchivedOptions) (item *items.Item, err error) {
	begin := time.Now()

	m.logger.Debug("GetArchived.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("spaceID", spaceID),
		zap.Reflect("envID", envID),
		zap.Reflect("collectionID", collectionID),
		zap.Reflect("id", id),
		zap.Reflect("options", options),
	)

	item, err = m.next.GetArchived(ctx, spaceID, envID, collectionID, id, options...)

	m.logger.Debug("GetArchived.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Reflect("item", item),
		zap.Error(err),
	)

	return item, err
}

func (m *accessLoggingMiddleware) GetPublished(ctx context.Context, spaceId string, envId string, collectionId string, id string, options ...*items.GetPublishedOptions) (item *items.Item, err error) {
	begin := time.Now()

	m.logger.Debug("GetPublished.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("spaceId", spaceId),
		zap.Reflect("envId", envId),
		zap.Reflect("collectionId", collectionId),
		zap.Reflect("id", id),
		zap.Reflect("options", options),
	)

	item, err = m.next.GetPublished(ctx, spaceId, envId, collectionId, id, options...)

	m.logger.Debug("GetPublished.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Reflect("item", item),
		zap.Error(err),
	)

	return item, err
}

func (m *accessLoggingMiddleware) GetRevision(ctx context.Context, spaceId string, envId string, collectionId string, id string, revisionId string, options ...*items.GetRevisionOptions) (item *items.Item, err error) {
	begin := time.Now()

	m.logger.Debug("GetRevision.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("spaceId", spaceId),
		zap.Reflect("envId", envId),
		zap.Reflect("collectionId", collectionId),
		zap.Reflect("id", id),
		zap.Reflect("revisionId", revisionId),
		zap.Reflect("options", options),
	)

	item, err = m.next.GetRevision(ctx, spaceId, envId, collectionId, id, revisionId, options...)

	m.logger.Debug("GetRevision.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Reflect("item", item),
		zap.Error(err),
	)

	return item, err
}

func (m *accessLoggingMiddleware) Introspect(ctx context.Context, item *items.Item, opts ...*items.IntrospectOptions) (itm *items.Item, sch *schema.Schema, err error) {
	begin := time.Now()

	m.logger.Debug("Introspect.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("item", item),
		zap.Reflect("opts", opts),
	)

	itm, sch, err = m.next.Introspect(ctx, item, opts...)

	m.logger.Debug("Introspect.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Reflect("itm", itm),
		zap.Reflect("sch", sch),
		zap.Error(err),
	)

	return itm, sch, err
}

func (m *accessLoggingMiddleware) ListRevisions(ctx context.Context, spaceId string, envId string, collectionId string, id string, options ...*items.ListRevisionsOptions) (items []*items.Item, total int, err error) {
	begin := time.Now()

	m.logger.Debug("ListRevisions.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("spaceId", spaceId),
		zap.Reflect("envId", envId),
		zap.Reflect("collectionId", collectionId),
		zap.Reflect("id", id),
		zap.Reflect("options", options),
	)

	items, total, err = m.next.ListRevisions(ctx, spaceId, envId, collectionId, id, options...)

	m.logger.Debug("ListRevisions.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Reflect("items", items),
		zap.Reflect("total", total),
		zap.Error(err),
	)

	return items, total, err
}

func (m *accessLoggingMiddleware) Publish(ctx context.Context, item *items.Item, options ...*items.PublishOptions) (err error) {
	begin := time.Now()

	m.logger.Debug("Publish.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("item", item),
		zap.Reflect("options", options),
	)

	err = m.next.Publish(ctx, item, options...)

	m.logger.Debug("Publish.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Error(err),
	)

	return err
}

func (m *accessLoggingMiddleware) Unarchive(ctx context.Context, item *items.Item, options ...*items.UnarchiveOptions) (err error) {
	begin := time.Now()

	m.logger.Debug("Unarchive.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("item", item),
		zap.Reflect("options", options),
	)

	err = m.next.Unarchive(ctx, item, options...)

	m.logger.Debug("Unarchive.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Error(err),
	)

	return err
}

func (m *accessLoggingMiddleware) Undelete(ctx context.Context, item *items.Item, options ...*items.UndeleteOptions) (err error) {
	begin := time.Now()

	m.logger.Debug("Undelete.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("item", item),
		zap.Reflect("options", options),
	)

	err = m.next.Undelete(ctx, item, options...)

	m.logger.Debug("Undelete.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Error(err),
	)

	return err
}

func (m *accessLoggingMiddleware) Unpublish(ctx context.Context, item *items.Item, options ...*items.UnpublishOptions) (err error) {
	begin := time.Now()

	m.logger.Debug("Unpublish.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("item", item),
		zap.Reflect("options", options),
	)

	err = m.next.Unpublish(ctx, item, options...)

	m.logger.Debug("Unpublish.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Error(err),
	)

	return err
}

func (m *accessLoggingMiddleware) Update(ctx context.Context, item *items.Item, options ...*items.UpdateOptions) (err error) {
	begin := time.Now()

	m.logger.Debug("Update.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("item", item),
		zap.Reflect("options", options),
	)

	err = m.next.Update(ctx, item, options...)

	m.logger.Debug("Update.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Error(err),
	)

	return err
}
