package items

import (
	"context"
)

type StubFindRequest struct {
	Context                context.Context
	SpaceID, EnvID, CollID string
	Filter                 *Filter
	Options                []*FindOptions
}

type StubFindResult struct {
	Items []*Item
	Total int
	Error error
}

type Stub struct {
	Items
	FindResult func(req StubFindRequest) StubFindResult
}

func (d *Stub) Find(ctx context.Context, spaceID, envID, collID string, filter *Filter, opts ...*FindOptions) ([]*Item, int, error) {
	res := d.FindResult(StubFindRequest{
		Context: ctx,
		SpaceID: spaceID,
		EnvID:   envID,
		CollID:  collID,
		Filter:  filter,
		Options: opts,
	})
	return res.Items, res.Total, res.Error
}
