// Code generated by gowrap. DO NOT EDIT.
// template: ../../../assets/templates/middleware/access_log.tmpl
// gowrap: http://github.com/hexdigest/gowrap

package middleware

//go:generate gowrap gen -p git.perx.ru/perxis/perxis-go/pkg/members -i Members -t ../../../assets/templates/middleware/access_log.tmpl -o access_logging_middleware.go -l ""

import (
	"context"
	"time"

	"git.perx.ru/perxis/perxis-go/pkg/auth"
	"git.perx.ru/perxis/perxis-go/pkg/members"
	"go.uber.org/zap"
)

// accessLoggingMiddleware implements members.Members that is instrumented with logging
type accessLoggingMiddleware struct {
	logger *zap.Logger
	next   members.Members
}

// AccessLoggingMiddleware instruments an implementation of the members.Members with simple logging
func AccessLoggingMiddleware(logger *zap.Logger) Middleware {
	return func(next members.Members) members.Members {
		return &accessLoggingMiddleware{
			next:   next,
			logger: logger,
		}
	}
}

func (m *accessLoggingMiddleware) Get(ctx context.Context, orgId string, userId string) (role members.Role, err error) {
	begin := time.Now()

	m.logger.Debug("Get.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("orgId", orgId),
		zap.Reflect("userId", userId),
	)

	role, err = m.next.Get(ctx, orgId, userId)

	m.logger.Debug("Get.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Reflect("role", role),
		zap.Error(err),
	)

	return role, err
}

func (m *accessLoggingMiddleware) ListMembers(ctx context.Context, orgId string) (members []*members.Member, err error) {
	begin := time.Now()

	m.logger.Debug("ListMembers.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("orgId", orgId),
	)

	members, err = m.next.ListMembers(ctx, orgId)

	m.logger.Debug("ListMembers.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Reflect("members", members),
		zap.Error(err),
	)

	return members, err
}

func (m *accessLoggingMiddleware) ListOrganizations(ctx context.Context, userId string) (organizations []*members.Member, err error) {
	begin := time.Now()

	m.logger.Debug("ListOrganizations.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("userId", userId),
	)

	organizations, err = m.next.ListOrganizations(ctx, userId)

	m.logger.Debug("ListOrganizations.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Reflect("organizations", organizations),
		zap.Error(err),
	)

	return organizations, err
}

func (m *accessLoggingMiddleware) Remove(ctx context.Context, orgId string, userId string) (err error) {
	begin := time.Now()

	m.logger.Debug("Remove.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("orgId", orgId),
		zap.Reflect("userId", userId),
	)

	err = m.next.Remove(ctx, orgId, userId)

	m.logger.Debug("Remove.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Error(err),
	)

	return err
}

func (m *accessLoggingMiddleware) RemoveAll(ctx context.Context, orgId string) (err error) {
	begin := time.Now()

	m.logger.Debug("RemoveAll.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("orgId", orgId),
	)

	err = m.next.RemoveAll(ctx, orgId)

	m.logger.Debug("RemoveAll.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Error(err),
	)

	return err
}

func (m *accessLoggingMiddleware) Set(ctx context.Context, orgId string, userId string, role members.Role) (err error) {
	begin := time.Now()

	m.logger.Debug("Set.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("orgId", orgId),
		zap.Reflect("userId", userId),
		zap.Reflect("role", role),
	)

	err = m.next.Set(ctx, orgId, userId, role)

	m.logger.Debug("Set.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Error(err),
	)

	return err
}
