// Code generated by gowrap. DO NOT EDIT.
// template: ../../../assets/templates/middleware/access_log.tmpl
// gowrap: http://github.com/hexdigest/gowrap

package middleware

//go:generate gowrap gen -p git.perx.ru/perxis/perxis-go/pkg/users -i Users -t ../../../assets/templates/middleware/access_log.tmpl -o access_logging_middleware.go -l ""

import (
	"context"
	"time"

	"git.perx.ru/perxis/perxis-go/pkg/auth"
	"git.perx.ru/perxis/perxis-go/pkg/options"
	"git.perx.ru/perxis/perxis-go/pkg/users"
	"go.uber.org/zap"
)

// accessLoggingMiddleware implements users.Users that is instrumented with logging
type accessLoggingMiddleware struct {
	logger *zap.Logger
	next   users.Users
}

// AccessLoggingMiddleware instruments an implementation of the users.Users with simple logging
func AccessLoggingMiddleware(logger *zap.Logger) Middleware {
	return func(next users.Users) users.Users {
		return &accessLoggingMiddleware{
			next:   next,
			logger: logger,
		}
	}
}

func (m *accessLoggingMiddleware) Create(ctx context.Context, user *users.User) (created *users.User, err error) {
	begin := time.Now()

	m.logger.Debug("Create.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("user", user),
	)

	created, err = m.next.Create(ctx, user)

	m.logger.Debug("Create.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Reflect("created", created),
		zap.Error(err),
	)

	return created, err
}

func (m *accessLoggingMiddleware) Delete(ctx context.Context, id string) (err error) {
	begin := time.Now()

	m.logger.Debug("Delete.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("id", id),
	)

	err = m.next.Delete(ctx, id)

	m.logger.Debug("Delete.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Error(err),
	)

	return err
}

func (m *accessLoggingMiddleware) Find(ctx context.Context, filter *users.Filter, options *options.FindOptions) (users []*users.User, total int, err error) {
	begin := time.Now()

	m.logger.Debug("Find.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("filter", filter),
		zap.Reflect("options", options),
	)

	users, total, err = m.next.Find(ctx, filter, options)

	m.logger.Debug("Find.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Reflect("users", users),
		zap.Reflect("total", total),
		zap.Error(err),
	)

	return users, total, err
}

func (m *accessLoggingMiddleware) Get(ctx context.Context, id string) (user *users.User, err error) {
	begin := time.Now()

	m.logger.Debug("Get.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("id", id),
	)

	user, err = m.next.Get(ctx, id)

	m.logger.Debug("Get.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Reflect("user", user),
		zap.Error(err),
	)

	return user, err
}

func (m *accessLoggingMiddleware) GetByIdentity(ctx context.Context, identity string) (user *users.User, err error) {
	begin := time.Now()

	m.logger.Debug("GetByIdentity.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("identity", identity),
	)

	user, err = m.next.GetByIdentity(ctx, identity)

	m.logger.Debug("GetByIdentity.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Reflect("user", user),
		zap.Error(err),
	)

	return user, err
}

func (m *accessLoggingMiddleware) Update(ctx context.Context, user *users.User) (err error) {
	begin := time.Now()

	m.logger.Debug("Update.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("user", user),
	)

	err = m.next.Update(ctx, user)

	m.logger.Debug("Update.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Error(err),
	)

	return err
}
